#pragma once
#include <vector>

// The infamous bubble sort
// Do not use.
template <typename Type>
void libSort(Type* startPtr, Type* endPtr)
{
	sort(startPtr, endPtr + 1);
}

template <typename Type>
void bubbleSort(Type* startPtr, Type* endPtr)
{
	int nElements = endPtr - startPtr + 1;
	bool swapMade = true;

	while(swapMade)
	{
		swapMade = false;
		for (int i = 1; i < nElements; i++)
		{
			if (startPtr[i - 1] > startPtr[i])
			{
				swapMade = true;
				Type temp = startPtr[i];
				startPtr[i] = startPtr[i - 1];
				startPtr[i - 1] = temp;
			}
		}
	}
	std::vector<Type> result;
	for (int i = 0; i < nElements; i++)
	{
		result.push_back(startPtr[i]);
	}
}